Attribute VB_Name = "Module1"
Option Explicit
'---------------------------------------------------------------------------
'VBToolbox Console and Web-CGI Example
'Copyright (C) M Shaw 2008 - Freeware
'http://vbtoolbox.kerys.co.uk
'---------------------------------------------------------------------------
'Original example console I/O code per Microsoft MSDN Developer site
'http://support.microsoft.com/kb/q239588/
'Heavily modified and converted for MSLIB145.DLL
'---------------------------------------------------------------------------
'(DLL) Versions:
'1.15 - 30/Jun/2008
'1.18 - 14/Jul/2008
'1.19 - 18/Jul/2008 Added event logging on fatal-error using inbuilt logging
'                   Full HTML tags and body colour
'1.20 - 31/Aug/2009 Recompiled for DLL v1.21
'1.21 - 22/Jul/2010 Changed URL
'
'---------------------------------------------------------------------------
'IMPORTANT: *Optional* steps after compiling to convert to full console mode

'When compiled, this program will allocate a new console window and
'will not capture I/O from any current CMD console window I/O (C:\> prompt)
'You can change this program to a native console application by re-linking it
'Download the updated Microsoft LINK.EXE v5.12.8078 included with MASM32 9.0
'from http://www.masm32.com/masmdl.htm
'Once installed use the following command convert to a normal console app
'C:\MASM32\bin\LINK.EXE /EDIT /SUBSYSTEM:CONSOLE vbcgi.exe
'(LINK.EXE supplied with VB 5 (v4.20) will not work - you need v5.12+)
'Please note that this conversion is OPTIONAL
'---------------------------------------------------------------------------
'If launched from the VB IDE note that you will see BRIEF (<500msecs) output!
'---------------------------------------------------------------------------

'HTTP webserver environment variables (for reference)...

Public Const CGI_AUTH_TYPE         As String = "AUTH_TYPE"
Public Const CGI_CONTENT_LENGTH    As String = "CONTENT_LENGTH"
Public Const CGI_CONTENT_TYPE      As String = "CONTENT_TYPE"
Public Const CGI_GATEWAY_INTERFACE As String = "GATEWAY_INTERFACE"
Public Const CGI_HTTP_ACCEPT       As String = "HTTP_ACCEPT"
Public Const CGI_HTTP_REFERER      As String = "HTTP_REFERER"
Public Const CGI_HTTP_USER_AGENT   As String = "HTTP_USER_AGENT"
Public Const CGI_PATH_INFO         As String = "PATH_INFO"
Public Const CGI_PATH_TRANSLATED   As String = "PATH_TRANSLATED"
Public Const CGI_QUERY_STRING      As String = "QUERY_STRING"
Public Const CGI_REMOTE_ADDR       As String = "REMOTE_ADDR"
Public Const CGI_REMOTE_HOST       As String = "REMOTE_HOST"
Public Const CGI_REMOTE_USER       As String = "REMOTE_USER"
Public Const CGI_REQUEST_METHOD    As String = "REQUEST_METHOD"
Public Const CGI_SCRIPT_NAME       As String = "SCRIPT_NAME"
Public Const CGI_SERVER_NAME       As String = "SERVER_NAME"
Public Const CGI_SERVER_PORT       As String = "SERVER_PORT"
Public Const CGI_SERVER_PROTOCOL   As String = "SERVER_PROTOCOL"
Public Const CGI_SERVER_SOFTWARE   As String = "SERVER_SOFTWARE"

'An extract of MSLIB145.BAS ----------------------------------------------------------
Public Declare Function LibVersion Lib "mslib145.dll" () As Long
Public Declare Function OpenConsole Lib "mslib145" () As Long
Public Declare Function InNativeConsole Lib "mslib145" () As Boolean
Public Declare Function ConsoleOpen Lib "mslib145" () As Integer
Public Declare Sub CloseConsole Lib "mslib145" ()
Public Declare Function ConsoleTitle Lib "mslib145" (ByVal S As String) As Long
Public Declare Function WriteLn Lib "mslib145" (ByVal S As String) As Long
Public Declare Function ReadLn Lib "mslib145" (ByVal l As Long) As String
Public Declare Sub Pause Lib "mslib145" (Optional ByVal S As String = "Press a key...")
Public Declare Function HideConsole Lib "mslib145" () As Long
Public Declare Function ShowConsole Lib "mslib145" () As Long
Public Declare Sub Cls Lib "mslib145" ()
Public Declare Function GetCGIArgs Lib "mslib145.dll" (ByVal S As String, ByRef v As Variant) As Integer
Public Declare Function URLEncode Lib "mslib145.dll" (ByVal S As String) As String
Public Declare Function URLDecode Lib "mslib145.dll" (ByVal S As String) As String
Public Declare Function PHPDateNow Lib "mslib145.dll" (Optional ByVal S As String) As String

Public Const VERSION As Long = 119          ' This release needs this DLL ID 1.13 or higher
Public Const INVALID_HANDLE_VALUE = -1      ' Windows API return
Public Const EXENAME = "VBCGI"              ' For logging
Public LF As String                         ' Line feed char
Public Const WEBSITE = "http://vbtoolbox.kerys.co.uk"  ' The site

Sub Main()
    Dim i As Integer
    Dim sReadBuffer As String
    Dim iPos As Integer
    Dim ERL As Integer                      ' Error handling line number
    Dim CGIContentLength As Long
    Dim v As Variant                        ' GetCGIArgs()
    Dim WEBURL As String
    Dim Q As String
    On Error GoTo Error
    
    WEBURL = "<a href=" & Chr$(34) & WEBSITE & Chr$(34) & ">" & WEBSITE & "</a> "
    LF = Chr$(10)   ' New-line "\n", 0x0a
    Q = Chr$(34)    ' Quote character
    
    If IsDLLInstalled() Then
        If LibVersion() < VERSION Then
            ' * NEVER * use msgbox() etc. in production code!! (this code for demo use only)
            ' System errors and other problems should be logged to file and need no human interaction
            'MsgBox "Wrong DLL version for this test program version v" & Format$(LibVersion() / 100#) & " found" & vbCrLf & "I want version v" & Format$(Val(VERSION) / 100), vbCritical, "Outdated MSLIB145.DLL found"
            App.LogEvent "Wrong DLL version for this test program version v" & Format$(LibVersion() / 100#) & " found" & vbCrLf & "I want version v" & Format$(Val(VERSION) / 100), vbLogEventTypeError
            ' *****************************************************************************
            End
        End If
    Else
        ' * NEVER * use msgbox() etc. in production code!! (this code for demo use only)
        'MsgBox "DLL MSLIB145.DLL is not installed or in the PATH", vbCritical, "Outdated MSLIB145.DLL found"
        App.LogEvent vbCrLf & "DLL MSLIB145.DLL is not installed or in the PATH", vbLogEventTypeError
        End     ' CGI needs to end quietly and log any problems to file
    End If
    

    If (OpenConsole() = INVALID_HANDLE_VALUE) Then ' INVALID_HANDLE_VALUE is -1
        App.LogEvent vbCrLf & EXENAME & " Couldn't open a console window", vbLogEventTypeError
        End     ' DO NOT use msgbox() etc.
    End If
    
    ERL = 10
    WriteHTTPHeader     ' Essential to do this first or you will get a server 500 error!
        
    ERL = 20
    CGIContentLength = 0
    If Environ$(CGI_CONTENT_LENGTH) <> "" Then    ' Fetch whichever content length
        CGIContentLength = CLng(Environ$(CGI_CONTENT_LENGTH))
    End If
    ERL = 30
    WriteLn "<html><head></head><body  bgcolor=" & Q & "#FFFFB3" & Q & ">"
    WriteLn "<h2>This is a demo CGI program for VBToolbox (MSLIB145.DLL) - a VB 5/6 add-in DLL</h2><p>" & vbCrLf
    WriteLn WEBURL
    WriteLn " - Running DLL version " & Format$(LibVersion() / 100#) & " - the date is " & PHPDateNow() & "<br>" & vbCrLf
    WriteLn "This program "   ' We can test to see what kind of console window we are running in...
    If InNativeConsole() Then
        WriteLn "has been successfully converted using LINK.EXE or EDITBIN.EXE /EDIT /SUBSYSTEML:CONSOLE<p>" & LF
    Else
        WriteLn "is running as a Windowed app adapted for spawned console output in a new window<br>" & LF
        WriteLn "It has not yet converted using version 5.12.8078 of LINK.EXE /EDIT /SUBSYSTEM:CONSOLE &lt;filename&gt;<br>" & LF
        'If converted and InNativeConsole() is false then almost certainly CGI mode
        WriteLn "(Or it is running as a HTTP server CGI process - InNativeConsole() won't detect this)<p>" & LF
    End If
    
    
    If CGIContentLength < 1 Then    ' No content. Assume running as CGI rather than CMD for now
        WriteLn "Error - CGI_CONTENT_LENGTH environment variable not set! - you probably accessed this program directly<br>" & vbCrLf
        WriteLn "You need to <b>POST</b> data to this program using the HTML form code suggested for TEST.HTM<br>" & vbCrLf
        CloseConsole                ' Once you call CloseConsole() WriteLn will send to "/dev/null" until reopened
        End
    End If
        
    ERL = 40
    
    WriteLn "CGI content length = " & Format$(CGIContentLength) & " characters - " & vbCrLf
    WriteLn "The command string argument (Command$) is [" & Command$() & "]<p>" & LF
    ERL = 50
    sReadBuffer = ReadLn(CGIContentLength) ' Read client's input
    ' Find '=' in the name/value pair and parse the buffer
    ERL = 60
    iPos = InStr(sReadBuffer, "=")  ' Split off the arg
    sReadBuffer = Mid$(sReadBuffer, iPos + 1)
        
    ERL = 70
    If sReadBuffer <> "" Then
        WriteLn "<h2>You input was: [" & URLDecode(sReadBuffer) & "] (URL-decoded)</h2>"
        WriteLn "<b>You input was: [" & sReadBuffer & "] (non-decoded)</b><p>"
        i = GetCGIArgs(Environ("QUERY_STRING"), v)
        
        If Not IsEmpty(v) Then
            WriteLn "<hr>The CGI QUERY_STRING was [" & Environ("QUERY_STRING") & "]<br>"
            WriteLn "The query string had " & Format$(i) & " entries<p>"
            For i = LBound(v) To UBound(v)
                WriteLn "CGI Arg(" & Format$(i) & ")=[" & v(i) & "]<br>"
            Next
            WriteLn "<hr>"
        End If
    Else
        WriteLn "You didn't input anything"
    End If
    ERL = 80
    WriteLn "<b>Here's your server environment</b><br>" & vbCrLf
    ShowEnv
    WriteLn "</body></html>"
    CloseConsole
    Exit Sub
    
Error:
    'Enable for debugging outside of the CGI environment only
    'NEVER require user-input for production CGI code - always log problems to file
    'MsgBox "Error " & Format$(Err.Number) & " (" & Err.Description & ") at line " & Format$(ERL)
    App.LogEvent vbCrLf & "Error:" & Format$(Err.Number) & " (" & Err.Description & ") at line " & Format$(ERL)
    Resume Next
End Sub
Public Sub ShowEnv()
    Dim Indx As Integer
    Dim EnvString As String
    Indx = 1    ' Initialize index to 1.
    Do
        EnvString = Environ(Indx) ' Get environment
        WriteLn EnvString & "<br>"
        Indx = Indx + 1
    Loop Until EnvString = ""
End Sub
Public Sub WriteHTTPHeader()
    'WriteLn "HTTP/1.0 200 OK" & vbCrLf ' May be required in Abyss or other servers
    WriteLn "Content-Type: text/html" & Chr$(10) & Chr$(10)
End Sub
Public Function IsDLLInstalled() As Boolean
    Dim r As Long
    IsDLLInstalled = True
    On Error GoTo NoDll
    r = LibVersion()           'This is common to all versions (was _libversion Alias)
    On Error GoTo 0
    Exit Function

NoDll:
    IsDLLInstalled = False
    Debug.Print "Error "; Err.Number; " - "; Err.Description; ") in IsDLLInstalled()"
    App.LogEvent "Error " & Format$(Err.Number) & " - " & Err.Description & ") in IsDLLInstalled()", vbLogEventTypeError
    Resume Next
End Function

'Use this form for testing - compile project as "\cgi-bin\VBCGI.EXE" and save this form as TEST.HTM
'Remember to remove single quote comment marks before saving!
'You can download portable MicroApache to test this from http://microapache.kerys.co.uk
'<------ SNIP ------>
'<HTML>
'<HEAD>
'<TITLE>Testing MSLIB145.DLL CGI</TITLE>
'</HEAD>
'<BODY>
'<FORM action="/cgi-bin/vbcgi.exe?parameters=are-ignored&one=1&2=two&three=3" method="POST">
'<INPUT TYPE="TEXT" NAME="Name"> Name<BR>
'<INPUT TYPE="SUBMIT">
'</FORM>
'</BODY>
'</HTML>
'<------ SNIP ------>

'End of File -------------------------
